{% extends "starbase.html" %}
{% load i18n %}
{% load server_tags %}
{% load cache %}
{% load more_like_this %}
{% load crispy_forms_tags %}
{% load static %}

{% block page_title %}
    {{ post.title }}
{% endblock %}

{% block extras %}

    <script type="text/javascript"
            src="{% static "lib/pagedown/Markdown.Converter.js" %}"></script>
    <script type="text/javascript"
            src="{% static "lib/pagedown/Markdown.Sanitizer.js" %}"></script>
    <script type="text/javascript"
            src="{% static "lib/pagedown/Markdown.Editor.js" %}"></script>

    {#  Markdown editor style #}
    <link rel="stylesheet" href={% static "lib/pagedown/markdown.css" %}>

{% endblock %}

{% block content %}

    {#  {% search_bar %} #}

    <div class="row page-content-container" itemscope itemtype="http://schema.org/QAPage">

        <div class="col-xs-12 col-md-9 ">

            <div id="post-details">
                {# This is the toplevel post #}
                <span class="root" itemscope itemtype="http://schema.org/CreativeWork">
                    {% post_body post user post.tree %}
                </span>


                {# Render each answer for the post #}
                {% for answer in post.answers %}
                    <span class="answer" itemscope itemtype="http://schema.org/CreativeWork">
                        {% post_body answer user post.tree %}
                    </span>
                {% endfor %}

                {#  This is required element to access the token in javascript #}
                <span id="csrf_token">{% csrf_token %}</span>

                {# Generate the form to post an answer #}
                
                {% if post.type != Post.ARTICLE and post.type != Post.TEMPLATE_ARTICLE %}

                    <div>

                        {#  Below we could do an if/else but it is very hard to follow #}

                        {#  Anonymous users. #}
                        {% if not user.is_authenticated %}
                            <div class="alert alert-info">
                                {% url 'login' as login_url %}
                                {% blocktrans %}Please <a href="{{login_url}}">log in</a> to add an answer.{% endblocktrans %}
                            </div>
                        {% endif %}

                        {#  Closed posts cannot get more answers #}
                        {% if not post.is_open %}
                            <div class="alert alert-warning">
                                {% blocktrans %}The thread is closed. No new answers may be added.{% endblocktrans %}
                            </div>
                        {% endif %}

                        {#  Authenticated users on an open post #}
                        {% if user.is_authenticated and post.is_open %}
                            <div class="form-group">
                            
                            <h3>{% trans "Your answer" %}</h3>

                            <div class="alert alert-success">
                                {% blocktrans %}
                                <p><strong>Note:</strong> Answers should only be used to respond to the original post at the top of this page.
                                </p>

                                <p>
                                    Use the <a>comment</a> or <a>reply</a> buttons above to respond to someone, ask for clarifications, request more details etc.
                                </p>

                                <p>
                                    You can also open a <a>meta-discussion</a> if you feel that it is necessary.
                                </p>
                                {% endblocktrans %}
                            </div>

                            <form role="form" id="answer-form" method="post"
                                  action="{% url 'new-answer' post.id %}">
                                {% csrf_token %}
                                
                                {{ form }}

                                <input type="submit" name="submit" value="Submit Answer" class="btn btn-primary" id="submit-id-submit">

                            </form>
                            </div>
                        {% endif %}
                    </div>
                
                {% endif %}

            </div>
        </div>
        <div class="col-xs-12 col-md-3 sidebar">
            {% cache 600 "similar" post.id %}
                
                {% if post.mentions %}

                    <div class="sidebar-item">

                        <div class="head">{% trans "Posts mentioning this thread" %}</div>


                        <ul class="more-like-this">
                            {% for mentioning_post in post.mentions %}
                                <li>
                                    <a href="{{ mentioning_post.get_absolute_url }}">{{ mentioning_post.title }} </a>

                                </li>
                            {% endfor %}
                        </ul>

                    </div>

                {% endif %}

                <div class="sidebar-item">

                    <div class="head">{% trans "Similar posts" %} &bull; <a href="{% url 'search-page' %}">{% trans "Search" %} &raquo;</a></div>

                    {% more_like_this post as related limit 25 %}

                    <ul class="more-like-this">
                        {% for row in related %}
                            {% with row.object as post %}
                                {% if post.is_toplevel %}
                                    <li>
                                        <a href="{{ post.get_absolute_url }}">{{ post.title }} </a>

                                        <div class="peek">{{ post.peek|truncatechars:100 }}</div>
                                    </li>
                                {% endif %}
                            {% endwith %}
                            {%  if forloop.counter == 3 %}
                                {% include "banners/sidebar.html" %}
                            {%  endif %}
                        {% empty %}

                            {% include "banners/sidebar.html" %}

                            <li>Nothing matches yet.</li>

                        {% endfor %}
                    </ul>

                </div>
            {% endcache %}
        </div>
    </div>
    <script src="/static/lib/prism/prism.js" type="text/javascript"></script>

{% endblock %}
